/*****************************************************************************************
* SENSINOV ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016 SENSINOV, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of COMPANY. 
* The intellectual and technical concepts contained herein are proprietary to COMPANY 
* and may be covered by France and Foreign Patents, patents in process, and are protected 
* by trade secret or copyright law. Dissemination of this information or reproduction 
* of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY. Access to the source code contained herein is hereby forbidden to 
* anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or 
* disclosure  of  this source code, which includes * information that is confidential 
* and/or proprietary, and is a trade secret, of  COMPANY. ANY REPRODUCTION, MODIFICATION,
* DISTRIBUTION, PUBLIC  PERFORMANCE, OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE 
* CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN 
* VIOLATION OF APPLICABLE * LAWS AND INTERNATIONAL TREATIES. THE RECEIPT OR POSSESSION OF
* THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS TO 
* REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING
* THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*******************************************************************************************/

//var webSocket ;
var aeName = "dashboard_app"; // must be unique for each client
var subName = "sub_dashboard"; // must be unique for each client
//var subscribed = false ; // this variable used to unsubscribe when the view is changed
//var refreshState = true ; 

// vars to store subscription target id elements 
var csernStore = "";
var csenameStore = "";
var apprnStore = "";
var cntrnStore = "";

var serie ;
var cntsel ;

if(getUrlVar("context")!="" && getUrlVar("cseId")!="" && getUrlVar("wsport")!=""){
	document.cookie="context="+getUrlVar("context");
	document.cookie="cseid="+getUrlVar("cseId");
	document.cookie="wsport="+getUrlVar("wsport");
	
}

/*if(getCookie("context")=="" || getCookie("cseId")=="" || getCookie("wsport")==""){
	document.cookie="context=/~";
	document.cookie="cseid=server";	
	//document.cookie="wsport=80";
}*/

var cseBase;
var context;
var username;
var password;
var wsport;

function getUrlVar(key){
	  var result = new RegExp(key + "=([^&]*)", "i").exec(window.location.search);
	  return result && unescape(result[1]) || "";
	}


if((getCookie("username")!="" && getCookie("username")!=null) /*&& (getCookie("password")!="" && getCookie("password")!=null)*/){
	username = getCookie("username");
	password= getCookie("password");
	context= getCookie("context");
	cseBase= getCookie("cseid");
	wsport= getCookie("wsport");
}else{
	window.location.replace("login.html");
}

function logout(){
	document.cookie = 'username=;expires=Thu, 01 Jan 1970 00:00:01 GMT;';
	username=null;
	password=null;
	wsport=null;
	window.location.replace("login.html");
}

function getTree(){
	//unsubscribeViaWS(csernStore, csenameStore, apprnStore, cntrnStore);
	document.getElementById("wrapper2").innerHTML="";
	$("#wrapper2").load("tree.html");
}

function getCse(){
	//unsubscribeViaWS(csernStore, csenameStore, apprnStore, cntrnStore);
	document.getElementById("wrapper2").innerHTML="";
	$("#wrapper2").load("select.html");

	$.ajax({
		type: "get",
		dataType: "json",
		url: context + "/"+cseBase + "?rcn=4",
        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},
		success: function(response4){
			console.log("*********************************");
			console.log("---------------"+cseBase);
			var rows='<tr id="1"  onclick=getApplications(id,"'+cseBase+'") onmouseover="hoverColor(id)" onmouseout="quitColor(id)"> '+
				'<td>'+ response4["m2m:cb"].csi +'</td>'+
				'<td>'+response4["m2m:cb"].rn+'</td>'+
				'<td>CSE</td>'+
				'<td>'+ response4["m2m:cb"].ct +'</td>'+
				'<td>'+ response4["m2m:cb"].lt +'</td>'+
				'<td>'+response4["m2m:cb"].acpi[0]+'</td>'+
				'<td>'+response4["m2m:cb"].poa[0]+'</td>'+
				'</tr>';
			console.log("---------------"+cseBase);
if(response4["m2m:cb"].csr!=null){
			$.each(response4["m2m:cb"].csr, function(i,v) {
				//console.log("---------------"+v.rn);
				rows=rows+'<tr id='+(i+2)+' onclick=getApplications(id,"'+v.rn+'") onmouseover="hoverColor(id)" onmouseout="quitColor(id)" >'+
				'<td>'+ v.csi +'</td>'+
				'<td>'+v.rn+'</td>'+
				'<td>CSE</td>'+
				'<td>'+ v.ct +'</td>'+
				'<td>'+ v.lt +'</td>' ;
				if(typeof v.acpi != 'undefined'){
					rows=rows+'<td>'+v.acpi[0]+'</td>' ;
				}else {rows=rows+'<td> </td>' ;}
				if(typeof v.poa != 'undefined'){
					rows=rows+'<td>'+v.poa[0]+'</td>' ;
				} else {rows=rows+'<td> </td>' ;}
				rows=rows+'</tr>';

			});
}
			console.log("*********************************");
			
			var elem = document.getElementById("divTable");
			elem.innerHTML = '<table class="table table-bordered"><thead><tr>'+
			'<th>Id</th>'+
			'<th>Name</th>'+
			'<th>Type</th>'+
			'<th>Creation time</th>'+
			'<th>Last modified time</th>'+
			'<th>Access control policy</th>'+
			'<th>Point of access</th>'+
			'</tr></thead>'+
			'<tbody>'+	rows +'</tbody></table>';
		}
	});
	
}

function getApplications(id,csern){
	//unsubscribeViaWS(csernStore, csenameStore, apprnStore, cntrnStore);
	document.getElementById("cse-name").innerHTML = " / " + "<a href='#' onclick=getApplications('"+id+"','"+csern+"')>"+csern+"</a>" ;
	document.getElementById("ae-name").innerHTML = "" ;
	document.getElementById("cnt-name").innerHTML = "" ;
	document.getElementById("divTable").innerHTML = "" ;
	console.log(context);
	$.ajax({
		type: "get",
		dataType: "json",
		url: context+"/"+csern+"?rcn=4",
        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},
		success: function(response3){
			console.log("*********************************");
			var csename = response3["m2m:cb"].rn ;
			var rows='';
			if(typeof response3["m2m:cb"].ae === 'undefined' ){
				document.getElementById("divTable").innerHTML = "<p>No Application registred in this cse</p>" ;
			} else {
				console.log(response3["m2m:cb"].ae);
				$.each(response3["m2m:cb"].ae, function(i,v) {
					//console.log("---------------"+v.rn);
					rows=rows+'<tr id=app_'+(i+1)+' onclick=getSensors(id,"'+csern+'","'+csename+'","'+v.rn+'") onmouseover="hoverColor(id)" onmouseout="quitColor(id)" >'+
					'<td>'+ v.aei +'</td>'+
					'<td>'+ v.rn +'</td>'+
					'<td>AE</td>'+
					'<td>'+ v.ct +'</td>'+
					'<td>'+ v.lt +'</td>';
					if(typeof v.acpi != 'undefined'){
						rows=rows+'<td>'+v.acpi[0]+'</td>' ;
					} else {rows=rows+'<td> </td>' ;}
					if(typeof v.poa != 'undefined'){
						rows=rows+'<td>'+v.poa[0]+'</td>' ;
					} else {rows=rows+'<td> </td>' ;}
					rows=rows+'</tr>';
//					'<td>'+v.poa.split(" ")[0]+'</td>'+ 
//					'<td>'+v.acpi.split(" ")[0]+'</td>'+
//					'</tr>';

				});
				console.log("*********************************");
				
				var elem = document.getElementById("divTable");
				elem.innerHTML = '<table class="table table-bordered"><thead><tr>'+
				'<th>Id</th>'+
				'<th>Name</th>'+
				'<th>Type</th>'+
				'<th>Creation time</th>'+
				'<th>Last modified time</th>'+
				'<th>Access control policy</th>'+
				'<th>Point of access</th>'+
				'</tr></thead>'+
				'<tbody>'+	rows +'</tbody></table>';
			}
			
		}
	});
}

function getSensors(id,csern,csename,apprn){
	//unsubscribeViaWS(csernStore, csenameStore, apprnStore, cntrnStore);
	document.getElementById("ae-name").innerHTML = " / " + "<a href='#' onclick=getSensors('"+id+"','"+csern+"','"+csename+"','"+apprn+"')>"+apprn+"</a>";
	document.getElementById("cnt-name").innerHTML = "" ;
	document.getElementById("divTable").innerHTML = "" ;

	$.ajax({
		type: "get",
		dataType: "json",
		url: context+"/"+csern+"/"+csename+"/"+apprn+"?rcn=4",
        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},

		success: function(response3){
			console.log("*********************************");
			var rows='';
			if(typeof response3["m2m:ae"].cnt === 'undefined' ){
				document.getElementById("divTable").innerHTML = "<p>No Sensor registred in this application</p>" ;
			} else {
				console.log(response3["m2m:ae"].cnt);
				var count = 0;
				$.each(response3["m2m:ae"].cnt, function(i,v) {
					//console.log("---------------"+v.rn);
					if(!v.rn.startsWith("cfg_") &&  !v.rn.startsWith("sys_") && !v.rn.startsWith("DESCRIPTOR")){
						rows=rows+'<tr id=sens_'+(i+1)+' onclick=getMetrics("'+csern+'","'+csename+'","'+apprn+'","'+v.rn+'") onmouseover="hoverColor(id)" onmouseout="quitColor(id)" >'+
						'<td>'+ v.ri +'</td>'+
						'<td>'+ v.rn +'</td>'+
						'<td>CNT</td>'+
						'<td>'+ v.ct +'</td>'+
						'<td>'+ v.lt +'</td>';
						
						if(typeof v.acpi != 'undefined'){
							rows=rows+'<td>'+v.acpi[0]+'</td>' ;
						} else {rows=rows+'<td> </td>' ;}
						rows=rows+'</tr>';
//						'<td>'+ v.lt +'</td>'+
//						'<td>'+v.acpi.split(" ")[0]+'</td>'+
//						'</tr>';
						count++;
					} 

				});
				console.log("*********************************");
				if(count>0){
					var elem = document.getElementById("divTable");
					elem.innerHTML = '<table class="table table-bordered"><thead><tr>'+
					'<th>Id</th>'+
					'<th>Name</th>'+
					'<th>Type</th>'+
					'<th>Creation time</th>'+
					'<th>Last modified time</th>'+
					'<th>Access control policy</th>'+
					'</tr></thead>'+
					'<tbody>'+	rows +'</tbody></table>';
				} else {
					document.getElementById("divTable").innerHTML = "<p>No Sensor registred in this application</p>" ;
				}
				
			}
		}
	});
}
var chartdrawed;
function getMetrics(csern,csename,apprn,cntrn){
	chartdrawed=false;
	//unsubscribeViaWS(csernStore, csenameStore, apprnStore, cntrnStore);
	cntsel = cntrn ;
	document.getElementById("divTable").innerHTML="";
	$("#divTable").load("metric.html");
	
	// get descriptor to fill desc-table and desc-buttons
	$.ajax({
		type: "get",
		dataType: "json",
		url: context+"/"+csern+"/"+csename+"/"+apprn+"/"+cntrn+"/DESCRIPTOR/la",
        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},

		success: function(response){
			document.getElementById("cnt-name").innerHTML = " / " + "<a href='#' onclick=getMetrics('"+csern+"','"+csename+"','"+apprn+"','"+cntrn+"')>"+cntrn+"</a>" ;
			var xml =    response["m2m:cin"].con; 
			xmlDoc = $.parseXML( xml );
			// fill desc table
			var rows='';
			$( xmlDoc ).find("str").each(function() {
		        var name = $(this).attr('name');
		        if(name == "type" || name == "location" || name == "unit"){
		        	rows=rows+'<tr><td>'+ name +'</td><td>'+ $(this).attr('val') +'</td></tr>';
		        }
		     });
			var elem = document.getElementById("desc");
			elem.innerHTML = '<table class="table table-bordered"><thead><tr><th>Name</th><th>Value</th></tr></thead>'+
			'<tbody>'+	rows +'</tbody></table>'; 
			
			// fill desc buttons
			var buttons="";
			$( xmlDoc ).find("op").each(function() {
		        var is = $(this).attr('is');
		        var name = $(this).attr('name'); 
		        if(is == "execute" && !name.startsWith("GET")){
		        	buttons=buttons+'<div style="float: left;margin-right:10px ;" ><input class="btn btn-primary" type=button onclick=executeOp("'+
		        		$(this).attr('href') +'","'+csern+'","'+csename+'","'+apprn+'","'+cntrn+'")  value="'+ $(this).attr('name') +'"/></div>';
		        	
		        	var href = $(this).attr('href');
		        	if(href.indexOf("[BYTE]")  !== -1){
		        		buttons=buttons+'<input type=range id="level" min="1" max="99"  style="width:200;"/>';
		        	}
		        }
		     });
			var elem = document.getElementById("descButtons");
			elem.innerHTML = buttons ;
		}
	});
	
	// get data to fill data-type and draw chart
	updateGreenWidgetAndChart(csern, csename, apprn, cntrn,false);

	// Start web socket
	//subscribeViaWS(csern, csename, apprn, cntrn);
}

function executeOp(uri,csern,csename,apprn,cntrn){
	console.log(uri);
	var uri2;
	if(uri.indexOf("[BYTE]")  !== -1){
		uri2 = uri.replace("[BYTE]", document.getElementById('level').value)
	}else{
		uri2=uri;
	}
	$.ajax({
		type: "POST",
		dataType: "xml",
		url: context+uri2,
        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},

		success: function(response){
			console.log("OK Button");

				setTimeout(function() {
					console.log("500");
					updateGreenWidgetAndChart(csern,csename,apprn,cntrn,true);
				}, 500);
				setTimeout(function() {
					console.log("2000");
					updateGreenWidgetAndChart(csern,csename,apprn,cntrn,true);
				}, 2000);
			
		} ,
		error: function(response,textStatus,error ){
			console.log("Non OK Button");
			console.log(textStatus);
			console.log(error);
		}
	});
}

//var data=null;
var chart=null;
var val=[];


/*setInterval(function () {
	//var x = (new Date()).getTime(), // current time
    //y = Math.round(Math.random() * 100);
	//val=[x,y]
}, 1000);*/




var series;

function drawChart(serie, type, unit) {

	chartdrawed=true;
	//$('#radarChart').highcharts().series[0].name="Renamed";

	Highcharts.setOptions({
        global : {
            useUTC : false
        } });

	 $('#radarChart').highcharts('StockChart', {

		 chart : {
	            events : {
	                load : function () {

	                    // set up the updating of the chart each second
	                    this.series[0].name=type;
	                    /*setInterval(function () {
	                        	//var x = (new Date()).getTime(), // current time
	                            //y = Math.round(Math.random() * 100);
		                        for(var i=0;i<val.length;i++){
		                        	console.log("Updating Serie with"+val[i]);
		                        	series.addPoint(val[i], true, false);
		                    	}
		                        if(val.length>0){
		                        	val=[];
		                        }

	                        
	                    }, 1000);*/
	                }
	            },
			 zoomType: 'x'
				 
				 
	 			
	    },
	    colors: ['#96c927', '#434348', '#90ed7d', '#f7a35c', '#8085e9', 
		          '#f15c80', '#e4d354', '#8085e8', '#8d4653', '#91e8e1']
	    ,
	    navigator: {
            maskFill: 'rgba(150, 201, 39,0.1)',//'rgba(150, 201, 39, 0.1)',
            handles: {
				backgroundColor: "#ebe7e8",
				borderColor: "#b2b1b6"
            },
   
            series: {
            	
            	color: '#96c927',
            	dataGrouping: {
            		smoothed: true
            	},
            	lineWidth: 1,
            	marker: {
            		enabled: false
            	}
            }
        },
        rangeSelector: {
            buttons: [{
                count: 1,
                type: 'minute',
                text: '1M'
            },{
                count: 5,
                type: 'minute',
                text: '5M'
            },{
                count: 1,
                type: 'hour',
                text: '1H'
            },{
                count: 1,
                type: 'day',
                text: '1D'
            },{
                type: 'all',
                text: 'All'
            }],
            inputEnabled: true,
            allButtonsEnabled: true,
            selected: 2
        },
        title : {
            text : ''
        },
        tooltip: {
            valueSuffix: unit
        },
        series : [{
        	id: 'serie-1',
        	//name : "aa",
            data : serie,
            
        }]
    });
}



/*$(window).resize(function(){
chart.draw(data, options);
});*/


function updateGreenWidgetAndChart(csern,csename,apprn,cntrn,last){
	if(last){
		$.ajax({
			type: "get",
			dataType: "json",
			url: context+"/"+csern+"/"+csename+"/"+apprn+"/"+cntrn+"/DATA/la",
	        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},

			success: function(response){
				upDateMetric(response,true,false);
			}
		});
	} else {
		$.ajax({
			type: "get",
			dataType: "json",
			url: context+"/"+csern+"/"+csename+"/"+apprn+"/"+cntrn+"/DATA?rcn=4",
	        headers : {"X-M2M-Origin" : username, "Accept":"application/json","X-M2M-Key" : password},
			success: function(response){
				upDateMetric(response,false,false);
			}
		});
	}
		
}

function upDateMetric(response,last,notify){
	console.log(last);
	var dataLa ;
	if(!last){
		serie = [];
		// each on data 
		//var size=response.cnt.cni;
		$.each(response["m2m:cnt"].cin, function(i,v) {
			//console.log("---------------"+v.rn);
			// data 
			// put data in chart
			xmlDoc = $.parseXML( v.con );
			$( xmlDoc ).find("str").each(function() {
		        var name = $(this).attr('name');
		        if(name == "value"){
		        	var value = $(this).attr('val') ;
		        	var date = v.ct.substring(0,4)+"-"+v.ct.substring(4,6)+"-"+v.ct.substring(6,11)+":"+v.ct.substring(11,13)+":"+v.ct.substring(13,15);
		        	
		        	if(value.startsWith("false")){
		        		serie.push([new Date(date).getTime(), 0 ]);
		        	} else if(value.startsWith("true")){
		        		serie.push([new Date(date).getTime(), 1 ]);
		        	} else {
		        		if(isNaN(Number(value))){
		        			serie.push([new Date(date).getTime(), 1 ]);
		        		} else {
		        			serie.push([new Date(date).getTime(), parseFloat(value) ]);
		        		}
		        	}
		        }			        
		     });
			$( xmlDoc ).find("int").each(function() {
		        var name = $(this).attr('name');
		        if(name == "value"){
		        	var value = $(this).attr('val') ;
		        	var date = v.ct.substring(0,4)+"-"+v.ct.substring(4,6)+"-"+v.ct.substring(6,11)+":"+v.ct.substring(11,13)+":"+v.ct.substring(13,15);
		        	//console.log(response.cnt.cni);
		        	//console.log(value);
		        	serie.push([new Date(date).getTime(), parseFloat(value) ]);
		        }			        
		     });
			$( xmlDoc ).find("bool").each(function() {
		        var name = $(this).attr('name');
		        if(name == "value"){
		        	var value = $(this).attr('val') ;
		        	var date = v.ct.substring(0,4)+"-"+v.ct.substring(4,6)+"-"+v.ct.substring(6,11)+":"+v.ct.substring(11,13)+":"+v.ct.substring(13,15);
		        	if(value.startsWith("false")){
		        		serie.push([(new Date(date)).getTime(), 0 ]);
		        	} else if(value.startsWith("true")){
		        		serie.push([(new Date(date)).getTime(), 1 ]);
		        	}
		        }			        
		     });
			dataLa = v ;
		});
	
	} else {
	console.log("last data received");
		// I have just the last data
		// put data in chart
		var v ;
		console.log("notify "+notify);
		if(notify){

			v = response ;
			xmlDoc = $.parseXML( v.con ) ;
		} else {
			v = response["m2m:cin"] ;
			xmlDoc = $.parseXML( v.con );
		}
		
		console.log("start finding");
		$( xmlDoc ).find("str").each(function() {
	        var name = $(this).attr('name');
	        if(name == "value"){
	        	var value = $(this).attr('val') ;
	        	var date = v.ct.substring(0,4)+"-"+v.ct.substring(4,6)+"-"+v.ct.substring(6,11)+":"+v.ct.substring(11,13)+":"+v.ct.substring(13,15);
	        	
	        	if(value.startsWith("false")){
	        		val.push([new Date(date).getTime(), 0 ]);
	        	} else if(value.startsWith("true")){
	        		val.push([new Date(date).getTime(), 1 ]);
	        	} else {
	        		if(isNaN(Number(value))){
	        			val.push([new Date(date).getTime(), 1 ]);
	        		} else {
	        			val.push([new Date(date).getTime(), parseFloat(value) ]);
	        		}
	        	}
	        }			        
	     });
		$( xmlDoc ).find("int").each(function() {
	        var name = $(this).attr('name');
	        if(name == "value"){
	        	var value = $(this).attr('val') ;
	        	var date = v.ct.substring(0,4)+"-"+v.ct.substring(4,6)+"-"+v.ct.substring(6,11)+":"+v.ct.substring(11,13)+":"+v.ct.substring(13,15);
	        	val.push([new Date(date).getTime(), parseFloat(value) ]);
	        }			        
	     });
		$( xmlDoc ).find("bool").each(function() {
	        var name = $(this).attr('name');
	        if(name == "value"){
	        	var value = $(this).attr('val') ;
	        	var date = v.ct.substring(0,4)+"-"+v.ct.substring(4,6)+"-"+v.ct.substring(6,11)+":"+v.ct.substring(11,13)+":"+v.ct.substring(13,15);
	        	if(value.startsWith("false")){
	        		val.push([(new Date(date)).getTime(), 0 ]);
	        	} else if(value.startsWith("true")){
	        		val.push([(new Date(date)).getTime(), 1 ]);
	        	}
	        }			        
	     });


		dataLa = v ;

		
		
		if(!chartdrawed){
    			console.log("INIT DRAW CHART");
			drawChart([], "", "");
			chartdrawed=true;

		}
			console.log("ADD POINT");
			$('#radarChart').highcharts().get("serie-1").addPoint(val[0], false, false);
			$('#radarChart').highcharts().redraw();
			$('#radarChart').highcharts().reflow();
		
		val=[];


	}
	console.log("Nothing");
	var type ;
	var unit ;
	// put last data in green widget
	console.log(dataLa.con);
	document.getElementById("data-time").innerHTML = dataLa.ct;
	// data-val data-type data-unit
	xmlDoc = $.parseXML( dataLa.con );
	$( xmlDoc ).find("str").each(function() {
        var name = $(this).attr('name');
        if(name == "type" ){
        	type = $(this).attr('val') ;
        	document.getElementById("data-type").innerHTML = type;
        } else if(name == "value"){
        	var val = $(this).attr('val') ;
        	if(val.startsWith("true")){
        		document.getElementById("data-val").innerHTML = "ON";
        	} else if(val.startsWith("false")){
        		document.getElementById("data-val").innerHTML = "OFF";
        	} else {
        		document.getElementById("data-val").innerHTML = val;
        	}
        } else if(name == "unit"){
        	unit = $(this).attr('val') ;
        	document.getElementById("data-unit").innerHTML = unit;
        }
        
     });
	$( xmlDoc ).find("int").each(function() {
        var name = $(this).attr('name');
        if(name == "type" ){
        	type = $(this).attr('val') ;
        	document.getElementById("data-type").innerHTML = type;
        } else if(name == "value"){
        	document.getElementById("data-val").innerHTML = $(this).attr('val');
        } else if(name == "unit"){
        	unit = $(this).attr('val') ;
        	document.getElementById("data-unit").innerHTML = unit;
        }
        
     });
	$( xmlDoc ).find("bool").each(function() {
        var name = $(this).attr('name');
        if(name == "type" ){
        	type = $(this).attr('val') ;
        	document.getElementById("data-type").innerHTML = type;
        } else if(name == "value"){
        	document.getElementById("data-val").innerHTML = $(this).attr('val');
        } else if(name == "unit"){
        	unit = $(this).attr('val') ;
        	document.getElementById("data-unit").innerHTML = unit;
        }
        
     });
	
	if(!last){
		drawChart(serie, type, unit);
	}

}


/*function activeResfresh(){
	if(refreshState){
		console.log("Disable refresh");
		refreshState = false ;
		document.getElementById("refreshButton").value = "Enable refresh";
	} else {
		console.log("Enable refresh");
		refreshState = true ;
		document.getElementById("refreshButton").value = "Disable refresh";
	}
}*/

function hoverColor(id){
	document.getElementById(id).style.backgroundColor = "#fbf8e9" ;
}

function quitColor(id){
	document.getElementById(id).style.backgroundColor = "white" ;
}
function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
}

/*function openWebSocket(){
	console.log("************ start websocket ************* ");
	subscribed = false;
	if ("WebSocket" in window){
		console.log("WebSocket is supported by your Browser!");

		// open web socket
		webSocket = new WebSocket("ws://"+location.hostname+":"+wsport+"/wsbinding");
		
		webSocket.onopen = function(){
			//create ae dashboard_app for the web interface
			setTimeout(function() {
				console.log("create ae");
				createAe();
			}, 3000);
		};

		webSocket.onmessage = function (evt) {
			// get message
			var message = evt.data;
			console.log("new message receiverd = [ "+message+" ]");
			//Retry until the registration successful  
	
			if(message=="registration failed"){
				// retry registration
				$("#status").text("Connection failed ! Make sure this dashboard is not already opened from another tab. ");
				$("#status-info").text("Trying again..");

				setTimeout(function() {
					console.log("retry create ae");
					createAe();
				}, 5000);
				return;
			}else if(message=="registration successful"){
				$("#status").text("");
				$("#status-info").text("Connection established.");
			}
			// get notify else ignore
			var messageJson = JSON.parse(message);
			try{
				var xmlData = messageJson["m2m:sgn"].nev.rep ;
				if(typeof xmlData != 'undefined'){
					console.log("xml data from notify = "+ messageJson["m2m:sgn"].nev.rep);
					if(refreshState){
						// filter notifications, accept just notifications pertaining to the current subscription 
						// "/mn-cse/mn-cse/Phidgets_platform/Luminosity_02/DATA/sub_dashboard"
						var subSur = "/"+csernStore+"/"+csenameStore+"/"+apprnStore+"/"+cntrnStore+"/DATA/"+subName ;
						console.log("subSur = "+subSur);
						if(subSur == messageJson["m2m:sgn"].sur){
							console.log("update metric="+xmlData);
							upDateMetric(xmlData,true,true);  
					
							
						}
					}
				}
			} catch(err) {
				console.log("not notif (error)");
			}
		};

		webSocket.onclose = function(){ 
			// websocket is closed.
			console.log("Connection is closed..."); 
			// re-open websocket
			openWebSocket();
		};
	} else {
		// The browser doesn't support WebSocket
		alert("WebSocket NOT supported by your Browser!");
	}
}*/

/*function subscribeViaWS(csern, csename, apprn, cntrn){
	//store target id for unsubscription 
	csernStore = csern;
	csenameStore = csename;
	apprnStore = apprn;
	cntrnStore = cntrn;
	var targetID = "/"+csern+"/"+csename+"/"+apprn+"/"+cntrn+"/DATA" ;
	var content = "{  \"m2m:sub\": {    \"nct\": \"2\",     \"nu\":\"/"+cseBase+"/Cae-admin\"  }}";
    var message = "{\"m2m:rqp\" : {\"op\" : 1,\"to\" : \"~"+targetID+"\",\"fr\" : \"Cae-admin\",\"tkt\" : \"changeme\,\"rqi\" : \"222\","
    		+ "\"ty\" : 23,\"nm\" : \""+subName+"\"  ,\"pc\" : "+content+"  } }";
    webSocket.send(message);
    subscribed = true ;
}*/

/*function unsubscribeViaWS(csern, csename, apprn, cntrn){
	if(subscribed){
		var targetID = "/"+csern+"/"+csename+"/"+apprn+"/"+cntrn+"/DATA/"+subName ;
	    var message = "{\"m2m:rqp\" : {\"op\" : 4,\"to\" : \"~"+targetID+"\",\"fr\" : \"Cae-admin\",\"tkt\" : \"changeme\,\"rqi\" : \"333\" } }";
	    webSocket.send(message);
	    subscribed = false ;
	}
}*/

/*function createAe(){
	var content = "{  \"m2m:ae\": { \"poa\":[\"ws://Cae-admin\"]  }}";
    var message = "{\"m2m:rqp\" : {\"op\" : 3,\"to\" : \"/"+cseBase+"/Cae-admin\",\"tkt\" : \"changeme\",\"fr\" : \"Cae-admin\",\"rqi\" : \"111\","
    		+ "\"ty\" : 2,\"nm\" : \""+aeName+"\",\"pc\" : "+content+"  } }";
    webSocket.send(message);
}*/